-- A2A L049 Constellation
-- Module version 1.1
-- March 17
-- Gnter Steiner


-- ## System functions ##

function InitVars ()

    -- uncomment to disable display
    AutopilotDisplayBlocked ()
    -- AutoDisplay = false

    A2A_Sperry_HDG_show ()

    SFAltHold = 0
    SFPitchHold = 0
end 

--[[
panel
Random
Paused
zulutime
BodyHead
StartDelay
Frames
HalfSec
Count10
Count4
Count60
Count20
LocalTime
10thSec
QuarterSec
BodyArm
Rand_eng
clockboardtime
TimeOff
TimeOn
ClearFoulingTimeOn
DATLoaded
T5thSec
Secondstotal
PerSec
fpsCounterINI
fpscountercalc
SystemCondSelect
fpscounter
SteamTime
PastValuesINI
VFESndTimeSinceTalked
--]]



function Timer ()

    if ipc.get("SFAltHold") == 1 then
        SperryFake_Alt ()
    end

    if ipc.get("SFPitchHold") == 1 then
        SperryFake_CurrPitch ()
    end



    if ipc.readLvar("FlapsLeverPos") == 0 then
    Connie_RPM_show ()
    else
    Connie_FlapsLever_show ()
    end
    -- autom disengage of Controls Lock - remove after Beta
    --if ipc.readLvar("ControlsLocked") == 1 then
    --ipc.writeLvar("ControlsLock", 0)
    --end

    if ipc.readLvar("L:Eng1_StarterInertiaWheelSpeed") > 1 then
    Eng1InMax = ipc.readLvar("L:Eng1_StarterInertiaWheelSpeedMax")
    Eng1InCurr = ipc.readLvar("L:Eng1_StarterInertiaWheelSpeed")
    Eng1InSpeed = math.floor((Eng1InCurr/Eng1InMax)*100)
    DspShow ("Eng1", Eng1InSpeed .. "%")
    end

    if ipc.readLvar("L:Eng2_StarterInertiaWheelSpeed") > 1 then
    Eng2InMax = ipc.readLvar("L:Eng2_StarterInertiaWheelSpeedMax")
    Eng2InCurr = ipc.readLvar("L:Eng2_StarterInertiaWheelSpeed")
    Eng2InSpeed = math.floor((Eng2InCurr/Eng2InMax)*100)
    DspShow ("Eng2", Eng2InSpeed .. "%")
    end

    if ipc.readLvar("L:Eng3_StarterInertiaWheelSpeed") > 1 then
    Eng3InMax = ipc.readLvar("L:Eng3_StarterInertiaWheelSpeedMax")
    Eng3InCurr = ipc.readLvar("L:Eng3_StarterInertiaWheelSpeed")
    Eng3InSpeed = math.floor((Eng3InCurr/Eng3InMax)*100)
    DspShow ("Eng3", Eng3InSpeed .. "%")
    end

    if ipc.readLvar("L:Eng4_StarterInertiaWheelSpeed") > 1 then
    Eng4InMax = ipc.readLvar("L:Eng4_StarterInertiaWheelSpeedMax")
    Eng4InCurr = ipc.readLvar("L:Eng4_StarterInertiaWheelSpeed")
    Eng4InSpeed = math.floor((Eng4InCurr/Eng4InMax)*100)
    DspShow ("Eng4", Eng4InSpeed .. "%")
    end

    --------
    if ipc.readLvar("ApRudderServoOn") == 1 then
    DspHDG_AP_on ()
    else
    DspHDG_AP_off ()
    end





    --A2A_Sperry_HDG_show ()



    --- current ALT
	--A2A_ALT = ipc.readDBL(0x6020)*100/3.28084
    --DspALT(A2A_ALT)

    -- units
    A2AUnits = ipc.readLvar("Units")

    temp_units = A2AUnits -- 1 - C, 0 - F
    --egt_units = A2AUnits  -- 1 - C, 0 - F
    --carb_units = A2AUnits -- 1 - C, 0 - F


    -- Cabin Temp

    local cab

    if temp_units == 1 then
        -- C
        cab = round(ipc.readLvar("CabinTemp")) .. 'C'
    else
        -- F
        cab = round(ipc.readLvar("CabinTemp")*1.8 + 32) .. 'F'
    end
    -- leading spaces
    while string.len(cab) < 4 do cab = " " .. cab end

    -- show MCP2 Cabin Temp
    com.write(dev, "DSP7".. cab, 8)



    -- CHT
    HighCHTTemp = ipc.readLvar("HighCHTTemp")
    HighCHT = ipc.readLvar("HighCHT")

    Eng1_CHT = math.floor(ipc.readLvar("Eng1_CHT"))
    Eng2_CHT = math.floor(ipc.readLvar("Eng2_CHT"))
    Eng3_CHT = math.floor(ipc.readLvar("Eng3_CHT"))
    Eng4_CHT = math.floor(ipc.readLvar("Eng4_CHT"))

    if Eng1_CHT >= Eng2_CHT and Eng1_CHT >= Eng3_CHT and Eng1_CHT >= Eng4_CHT then
    EngCHTTxt = Eng1_CHT
    EngCHTNum = "1"
    elseif Eng2_CHT >= Eng1_CHT and Eng2_CHT >= Eng3_CHT and Eng2_CHT >= Eng4_CHT then
    EngCHTTxt = Eng2_CHT
    EngCHTNum = "2"
    elseif Eng3_CHT >= Eng1_CHT and Eng3_CHT >= Eng2_CHT and Eng3_CHT >= Eng4_CHT then
    EngCHTTxt = Eng3_CHT
    EngCHTNum = "3"
    elseif Eng4_CHT >= Eng1_CHT and Eng4_CHT >= Eng2_CHT and Eng4_CHT >= Eng3_CHT then
    EngCHTTxt = Eng4_CHT
    EngCHTNum = "4"
    end

    if Eng1_CHT >= 242 or Eng2_CHT >= 242 or Eng3_CHT >= 242 or Eng4_CHT >= 242 then
    CHTHotTxt = "!" else CHTHotTxt = " "
    end


    -- Carb Air Temp
    Eng1CAT = math.floor(ipc.readLvar("L:Eng1_CarbAirTemp"))
    Eng2CAT = math.floor(ipc.readLvar("L:Eng2_CarbAirTemp"))
    Eng3CAT = math.floor(ipc.readLvar("L:Eng3_CarbAirTemp"))
    Eng4CAT = math.floor(ipc.readLvar("L:Eng4_CarbAirTemp"))

    if Eng1CAT <= Eng2CAT and Eng1CAT <= Eng3CAT and Eng1CAT <= Eng4CAT then
    EngCATTxt = Eng1CAT
    EngCATNum = "1"
    elseif Eng2CAT <= Eng1CAT and Eng2CAT <= Eng3CAT and Eng2CAT <= Eng4CAT then
    EngCATTxt = Eng2CAT
    EngCATNum = "2"
    elseif Eng3CAT <= Eng1CAT and Eng3CAT <= Eng2CAT and Eng3CAT <= Eng4CAT then
    EngCATTxt = Eng3CAT
    EngCATNum = "3"
    elseif Eng4CAT <= Eng1CAT and Eng4CAT <= Eng2CAT and Eng4CAT <= Eng3CAT then
    EngCATTxt = Eng4CAT
    EngCATNum = "4"
    end

    if Eng1CAT <= 3 or Eng1CAT <= 3 or Eng1CAT <= 3 or Eng1CAT <= 3 then
    CATcoldTxt = "!" else CATcoldTxt = " "
    end

    -- Selected Engine
    ESelVar = ipc.readLvar("L:EngineSelection")


    if ESelVar == 1 then ESelTxt = "Eng1 Sel"
    elseif ESelVar == 2 then ESelTxt = "Eng2 Sel"
    elseif ESelVar == 4 then ESelTxt = "Eng3 Sel"
    elseif ESelVar == 8 then ESelTxt = "Eng4 Sel"
    else ESelTxt = "CAT" .. EngCATNum .. CATcoldTxt .. EngCATTxt .. "C"
    end


    -- selected CHT
    CHTSelVar = ipc.readLvar("CHTselectorPos")



    -- CF
    CowlFlapsMoving = ipc.readLvar("CowlFlapsMoving")

    if CowlFlapsMoving >= 1 then
        Eng1_CFM = ipc.readLvar("Eng1_CowlFlapMoving")
        Eng2_CFM = ipc.readLvar("Eng2_CowlFlapMoving")
        Eng3_CFM = ipc.readLvar("Eng3_CowlFlapMoving")
        Eng4_CFM = ipc.readLvar("Eng4_CowlFlapMoving")


        CFUp1 = math.floor(ipc.readLvar("CowlFlap1Upper"))
        CFUp2 = math.floor(ipc.readLvar("CowlFlap2Upper"))
        CFUp3 = math.floor(ipc.readLvar("CowlFlap3Upper"))
        CFUp4 = math.floor(ipc.readLvar("CowlFlap4Upper"))
        if CFUp1 >= CFUp2 and CFUp1 >= CFUp3 and CFUp1 >= CFUp4 then
        CFUpM = CFUp1
        CFUpMTxt = "1"
        elseif CFUp2 >= CFUp1 and CFUp2 >= CFUp3 and CFUp2 >= CFUp4 then
        CFUpM = CFUp2
        CFUpMTxt = "2"
        elseif CFUp3 >= CFUp2 and CFUp3 >= CFUp1 and CFUp3 >= CFUp4 then
        CFUpM = CFUp3
        CFUpMTxt = "3"
        elseif CFUp4 >= CFUp2 and CFUp4 >= CFUp3 and CFUp4 >= CFUp1 then
        CFUpM = CFUp4
        CFUpMTxt = "4"
        end

        CFLow1 = math.floor(ipc.readLvar("CowlFlap1Lower"))
        CFLow2 = math.floor(ipc.readLvar("CowlFlap2Lower"))
        CFLow3 = math.floor(ipc.readLvar("CowlFlap3Lower"))
        CFLow4 = math.floor(ipc.readLvar("CowlFlap4Lower"))
        if CFLow1 >= CFLow2 and CFLow1 >= CFLow3 and CFLow1 >= CFLow4 then
        CFLowM = CFLow1
        CFLowMTxt = "1"
        elseif CFLow2 >= CFLow1 and CFLow2 >= CFLow3 and CFLow2 >= CFLow4 then
        CFLowM = CFLow2
        CFLowMTxt = "2"
        elseif CFLow3 >= CFLow2 and CFLow3 >= CFLow1 and CFLow3 >= CFLow4 then
        CFLowM = CFLow3
        CFLowMTxt = "3"
        elseif CFLow4 >= CFLow2 and CFLow4 >= CFLow3 and CFLow4 >= CFLow1 then
        CFLowM = CFLow4
        CFLowMTxt = "4"
        end


        if Eng1_CFM == 1 and Eng2_CFM == 0 and Eng3_CFM == 0 and Eng4_CFM == 0 then
        UpperTxtLong = "^CF1 " .. CFUp1 .. "%"
        LowerTxtLong = "vCF1 " .. CFLow1 .. "%"
        end
        if Eng1_CFM == 0 and Eng2_CFM == 1 and Eng3_CFM == 0 and Eng4_CFM == 0 then
        UpperTxtLong = "^CF2 " .. CFUp2 .. "%"
        LowerTxtLong = "vCF2 " .. CFLow2 .. "%"
        end
        if Eng1_CFM == 0 and Eng2_CFM == 0 and Eng3_CFM == 1 and Eng4_CFM == 0 then
        UpperTxtLong = "^CF3 " .. CFUp3 .. "%"
        LowerTxtLong = "vCF3 " .. CFLow3 .. "%"
        end
        if Eng1_CFM == 0 and Eng2_CFM == 0 and Eng3_CFM == 0 and Eng4_CFM == 1 then
        UpperTxtLong = "^CF4 " .. CFUp4 .. "%"
        LowerTxtLong = "vCF4 " .. CFLow4 .. "%"
        end
        if CowlFlapsMoving == 4 then
        UpperTxtLong = "^CF" .. CFUpM .. "%"
        LowerTxtLong = "vCF" .. CFLowM .. "%"
        end

--[[    elseif CowlFlapsMoving == 0 then
        if CHTSelVar == 1 then
        UpperTxtLong = "Sel CHT " .. CHTHotTxt
        LowerTxtLong = "#".. CHTSelVar .. "  " .. Eng1_CHT .. "C"
        elseif CHTSelVar == 2 then
        UpperTxtLong = "Sel CHT " .. CHTHotTxt
        LowerTxtLong = "#".. CHTSelVar .. "  " .. Eng2_CHT .. "C"
        elseif CHTSelVar == 3 then
        UpperTxtLong = "Sel CHT " .. CHTHotTxt
        LowerTxtLong = "#".. CHTSelVar .. "  " .. Eng3_CHT .. "C"
        elseif CHTSelVar == 4 then
        UpperTxtLong = "Sel CHT " .. CHTHotTxt
        LowerTxtLong = "#".. CHTSelVar .. "  " .. Eng4_CHT .. "C"
        end
--]]
    else
    UpperTxtLong = "CHT" .. EngCHTNum .. CHTHotTxt .. EngCHTTxt .. "C"
    LowerTxtLong = ESelTxt
    end

    FLIGHT_INFO1 = UpperTxtLong
    FLIGHT_INFO2 = LowerTxtLong


end





function A2A_Sperry_HDG_show ()
    Sperry_hdg = ipc.readLvar("ApRudderControl")
    DspHDG(Sperry_hdg)
end

function CHT_Selector_show ()
    ipc.sleep(10)
    CHTSelVar = ipc.readLvar("CHTselectorPos")
    if CHTSelVar == 0 then CHTSelTxt = "off"
    elseif CHTSelVar == 1 then CHTSelTxt = "#1"
    elseif CHTSelVar == 2 then CHTSelTxt = "#2"
    elseif CHTSelVar == 3 then CHTSelTxt = "#3"
    elseif CHTSelVar == 4 then CHTSelTxt = "#4"
    end
    DspShow ("CHT", CHTSelTxt)
end

function Connie_FlapsLever_show ()
    FlapVar = ipc.readLvar("FlapsLeverPos")
    if FlapVar == 0 then
    FlapTxt = "UP"
    elseif FlapVar == 1 then
    FlapTxt = "TO"
    elseif FlapVar == 2 then
    FlapTxt = "AP"
    elseif FlapVar == 3 then
    FlapTxt = "LD"
    end

    com.write(dev, "F/D"..FlapTxt, 8)
    com.write(dev, "A/T--"..FlapTxt, 8)

end

function Connie_RPM_show ()
    --- Prop RPM
    Eng1PRPM = ipc.readLvar("Propeller1ControlRPM")
    Eng2PRPM = ipc.readLvar("Propeller2ControlRPM")
    Eng3PRPM = ipc.readLvar("Propeller3ControlRPM")
    Eng4PRPM = ipc.readLvar("Propeller4ControlRPM")
    if Eng1PRPM <= Eng2PRPM and Eng1PRPM <= Eng3PRPM and Eng1PRPM <= Eng4PRPM then
    EngRPMNr = "#1"
    EngPRPM = Eng1PRPM
    elseif Eng2PRPM <= Eng1PRPM and Eng2PRPM <= Eng3PRPM and Eng2PRPM <= Eng4PRPM then
    EngRPMNr = "#2"
    EngPRPM = Eng2PRPM
    elseif Eng3PRPM <= Eng1PRPM and Eng3PRPM <= Eng2PRPM and Eng3PRPM <= Eng4PRPM then
    EngRPMNr = "#3"
    EngPRPM = Eng3PRPM
    elseif Eng4PRPM <= Eng1PRPM and Eng4PRPM <= Eng2PRPM and Eng4PRPM <= Eng3PRPM then
    EngRPMNr = "#4"
    EngPRPM = Eng4PRPM
    end
    com.write(dev, "A/T"..EngRPMNr, 8)
    com.write(dev, "F/D"..EngPRPM, 8)

end

function Connie_RPM_showbig ()
    --- Prop RPM
    Eng1PRPM = math.floor(ipc.readLvar("Propeller1ControlRPM"))
    Eng2PRPM = math.floor(ipc.readLvar("Propeller2ControlRPM"))
    Eng3PRPM = math.floor(ipc.readLvar("Propeller3ControlRPM"))
    Eng4PRPM = math.floor(ipc.readLvar("Propeller4ControlRPM"))
    if Eng1PRPM >= Eng2PRPM and Eng1PRPM >= Eng3PRPM and Eng1PRPM >= Eng4PRPM then
    EngRPMNr = "1"
    EngPRPM = Eng1PRPM
    elseif Eng2PRPM >= Eng1PRPM and Eng2PRPM >= Eng3PRPM and Eng2PRPM >= Eng4PRPM then
    EngRPMNr = "2"
    EngPRPM = Eng2PRPM
    elseif Eng3PRPM >= Eng1PRPM and Eng3PRPM >= Eng2PRPM and Eng3PRPM >= Eng4PRPM then
    EngRPMNr = "3"
    EngPRPM = Eng3PRPM
    elseif Eng4PRPM >= Eng1PRPM and Eng4PRPM >= Eng2PRPM and Eng4PRPM >= Eng3PRPM then
    EngRPMNr = "4"
    EngPRPM = Eng4PRPM
    end

    if Eng1PRPM <= Eng2PRPM and Eng1PRPM <= Eng3PRPM and Eng1PRPM <= Eng4PRPM then
    EngRPMNrlow = "1"
    EngPRPMlow = Eng1PRPM
    elseif Eng2PRPM <= Eng1PRPM and Eng2PRPM <= Eng3PRPM and Eng2PRPM <= Eng4PRPM then
    EngRPMNrlow = "2"
    EngPRPMlow = Eng2PRPM
    elseif Eng3PRPM <= Eng1PRPM and Eng3PRPM <= Eng2PRPM and Eng3PRPM <= Eng4PRPM then
    EngRPMNrlow = "3"
    EngPRPMlow = Eng3PRPM
    elseif Eng4PRPM <= Eng1PRPM and Eng4PRPM <= Eng2PRPM and Eng4PRPM <= Eng3PRPM then
    EngRPMNrlow = "4"
    EngPRPMlow = Eng4PRPM
    end
    DspShow ("RPM" .. EngRPMNr , EngPRPM .. "%", "^#" .. EngRPMNr .. " " .. EngPRPM .."%", "v#" .. EngRPMNrlow .. " " .. EngPRPMlow .."%" )

end




function A2A_CabinPressure_show ()
    --PlaneAlt = ipc.readUD(0x3324)
    CabAlt = math.floor(ipc.readLvar("CabinAltGoal"))

    if CabAlt <= 999 then CabGoal = "<80"
    elseif CabAlt >= 1000 and CabAlt <= 4749 then CabGoal = "100"
    elseif CabAlt >= 4750 and CabAlt <= 8199 then CabGoal = "150"
    elseif CabAlt >= 8200 and CabAlt <= 11399 then CabGoal = "200"
    elseif CabAlt >= 11400 and CabAlt <= 14499 then CabGoal = "200"
    elseif CabAlt >= 14500 then CabGoal = "300"
    end


    DspShow ("CAlt", CabAlt, "C " .. CabAlt .. "ft", "FL ".. CabGoal)
end


function VoltmeterSelector_show ()
    VoltSel = ipc.readLvar("Vol01234BBSelState")
    if VoltSel == 0 then VoltSelTxt = "off"
    elseif VoltSel == 1 then VoltSelTxt = "Gen1"
    elseif VoltSel == 2 then VoltSelTxt = "Gen2"
    elseif VoltSel == 3 then VoltSelTxt = "Gen3"
    elseif VoltSel == 4 then VoltSelTxt = "Gen4"
    elseif VoltSel == 5 then VoltSelTxt = "BAT"
    elseif VoltSel == 6 then VoltSelTxt = "MAIN"
    end
    Voltmeter = math.floor(ipc.readLvar("Voltmeter"))
    DspShow (VoltSelTxt, Voltmeter .. "V", "Voltmtr", VoltSelTxt .. " " ..Voltmeter .. "V")

end

-- ## Sperry AP ###############

function A2A_Sperry_RudderServo_on ()
    ipc.writeLvar("ApRudderServoOn", 1)
    DspShow ("AP R", "on", "Rudder", "Servo on")
end

function A2A_Sperry_RudderServo_off ()
    ipc.writeLvar("ApRudderServoOn", 0)
    DspShow ("AP R", "off", "Rudder", "Srvo off")
end

function A2A_Sperry_RudderServo_toggle ()
	if _tl("ApRudderServoOn", 0) then
      A2A_Sperry_RudderServo_on ()
	else
      A2A_Sperry_RudderServo_off ()
	end

end

--

function A2A_Sperry_ElevServo_on ()
    ipc.writeLvar("ApElevatorServoOn", 1)
    DspShow ("AP E", "on", "Elev", "Servo on")
end

function A2A_Sperry_ElevServo_off ()
    ipc.writeLvar("ApElevatorServoOn", 0)
    DspShow ("AP E", "off", "Elev", "Srvo off")
end

function A2A_Sperry_ElevServo_toggle ()
	if _tl("ApElevatorServoOn", 0) then
      A2A_Sperry_ElevServo_on ()
	else
      A2A_Sperry_ElevServo_off ()
	end

end


--

function A2A_Sperry_AilerServo_on ()
    ipc.writeLvar("ApAileronServoOn", 1)
    DspShow ("AP A", "on", "Ailer", "Servo on")
end

function A2A_Sperry_AilerServo_off ()
    ipc.writeLvar("ApAileronServoOn", 0)
    DspShow ("AP A", "off", "Ailer", "Srvo off")
end

function A2A_Sperry_AilerServo_toggle ()
	if _tl("ApAileronServoOn", 0) then
      A2A_Sperry_AilerServo_on ()
	else
      A2A_Sperry_AilerServo_off ()
	end

end


function A2A_Sperry_RuddAilElev_on ()
     A2A_Sperry_RudderServo_on ()
     A2A_Sperry_ElevServo_on ()
     A2A_Sperry_AilerServo_on ()
end

function A2A_Sperry_RuddAilElev_off ()
     A2A_Sperry_RudderServo_off ()
     A2A_Sperry_ElevServo_off ()
     A2A_Sperry_AilerServo_off ()
end

function A2A_Sperry_RuddAilElev_toggle ()
     A2A_Sperry_RudderServo_toggle ()
     A2A_Sperry_ElevServo_toggle ()
     A2A_Sperry_AilerServo_toggle ()
end




----
function A2ASperry_HDG_plus (a, b, c)
	if c == nil then
		_HEADING_BUG_INC ()
		return
	end
	sync_hdg = round(c / 360 * 65536)
	ipc.writeUW(0x07CC, sync_hdg)
end

function A2ASperry_HDG_plusfast (a, b, c)
	if c == nil then
		for i = 1, fast_hdg do
			_HEADING_BUG_INC ()
		end
		return
	end
	sync_hdg = round(c / 360 * 65536)
	ipc.writeUW(0x07CC, sync_hdg)
end

function A2ASperry_HDG_minus (a, b, c)
	if c == nil then
		_HEADING_BUG_DEC ()
		return
	end
	sync_hdg = round(c / 360 * 65536)
	ipc.writeUW(0x07CC, sync_hdg)
end

function A2ASperry_HDG_minusfast (a, b, c)
	if c == nil then
		for i = 1, fast_hdg do
			_HEADING_BUG_DEC ()
		end
		return
	end
	sync_hdg = round(c / 360 * 65536)
	ipc.writeUW(0x07CC, sync_hdg)
end


----



function A2A_Sperry_Elev_inc ()
   Sperry_elev = ipc.readLvar("ApElevatorControl")

   Sperry_elev = Sperry_elev - 1
   if Sperry_elev < -100 then Sperry_elev = -100 end
   ipc.writeLvar("ApElevatorControl", Sperry_elev)
   DspShow ("Elev", " " .. Sperry_elev*-1)

end


function A2A_Sperry_Elev_dec ()
   Sperry_elev = ipc.readLvar("ApElevatorControl")

   Sperry_elev = Sperry_elev + 1
   if Sperry_elev > 100 then Sperry_elev = 100 end
   ipc.writeLvar("ApElevatorControl", Sperry_elev)
   DspShow ("Elev", " " .. Sperry_elev*-1)

end

-- $$ Fake AP Functions

function SperryFake_Alt_hold_on ()
    SperryFake_CurrPitch_off ()
    ipc.set("SFAltHold", 1)
    DspALT_AP_on ()
    DspShow ("ALT", "hold")
end

function SperryFake_Alt_hold_off ()

    ipc.set("SFAltHold", 0)
    DspALT_AP_off ()
    DspShow ("ALT", "off")
    ipc.display("")
end

function SperryFake_Alt_hold_toggle ()
	if ipc.get("SFAltHold") == 1 then
        SperryFake_Alt_hold_off ()
	else
        SperryFake_Alt_hold_on ()
	end
end

function SperryFake_Alt ()

   A2Atime = ipc.readUB(0x023A)
   if A2Atime == 0 or
   A2Atime == 5 or
   A2Atime == 10 or
   A2Atime == 15 or
   A2Atime == 20 or
   A2Atime == 25 or
   A2Atime == 30 or
   A2Atime == 35 or
   A2Atime == 40 or
   A2Atime == 45 or
   A2Atime == 50 or
   A2Atime == 55 then
   --ipc.sleep(1000)
   A2AVert = ipc.readSD(0x030C)

        if A2AVert > 50 then
            A2A_Sperry_Elev_dec ()
        elseif A2AVert < -50 then
            A2A_Sperry_Elev_inc ()
        end
   end
   Sperry_elev = ipc.readLvar("ApElevatorControl")

   ipc.display("Target VS: 0 ft/min\nCurrent VS: " .. A2AVert .. " ft/min\nSperry Elev Value: " .. Sperry_elev)
end

----

function SperryFake_CurrPitch_on ()
    SperryFake_Alt_hold_off ()
    ipc.set("SFPitchHold", 1)
    A2ACurrVert = math.floor(ipc.readSD(0x030C))
    DspShow ("VS", "hold")
end

function SperryFake_CurrPitch_off ()

    ipc.set("SFPitchHold", 0)

    DspShow ("VS", "off")
    ipc.display("")
end

function SperryFake_CurrPitch_toggle ()
	if ipc.get("SFPitchHold") == 1 then
        SperryFake_CurrPitch_off ()
	else
        SperryFake_CurrPitch_on ()
	end
end



function SperryFake_CurrPitch ()

   -- A2Atime = ipc.readUB(0x023A)
   A2AVert = ipc.readSD(0x030C)

        if A2AVert > A2ACurrVert+100 then
            A2A_Sperry_Elev_dec ()
        elseif A2AVert < A2ACurrVert-100 then
            A2A_Sperry_Elev_inc ()
        end

   Sperry_elev = ipc.readLvar("ApElevatorControl")

   ipc.display("Target VS: ".. A2ACurrVert .. " ft/min\nCurrent VS: " .. A2AVert .. " ft/min\nSperry Elev Value: " .. Sperry_elev)
end


function A2A_Sperry_CurrentHDG ()
   	val = ipc.readDBL(0x2B00)
	ipc.writeUW("07cc", val/360*65536)
	DspHDG(val)
end



-- ## Electric ###############



function A2A_GPU_on ()
   ipc.writeLvar("ApuStarterGenSwitch", 2)
   DspShow ("GPU", "on")
end

function A2A_GPU_off ()
   ipc.writeLvar("ApuStarterGenSwitch", 1)
   DspShow ("GPU", "off")
end



function A2A_APU_toggle ()
	if _tl("ApuStarterGenSwitch", 1) then
       A2A_GPU_on ()
	else
       A2A_GPU_off ()
	end
end

--

--[[function A2A_Inverter_1on ()
    ipc.writeLvar("InverterSwitch", 0)
    DspShow ("Inv1", "on")
end

function A2A_Inverter_off ()
    ipc.writeLvar("InverterSwitch", 1)
    DspShow ("Inv", "off")
end

function A2A_Inverter_2on ()
    ipc.writeLvar("InverterSwitch", 2)
    DspShow ("Inv2", "on")
end
--]]

function A2A_MasterIgnition_on ()
   if ipc.readLvar("MasterIgnitionSwitch") == 0 then
   ipc.control(66535)
   end
   DspShow ("IGN", "on")
end

function A2A_MasterIgnition_off ()
   if ipc.readLvar("MasterIgnitionSwitch") == 1 then
   ipc.control(66535)
   end
   DspShow ("IGN", "off")
end

function A2A_MasterIgnition_toggle ()
	if _tl("MasterIgnitionSwitch", 0) then
       A2A_MasterIgnition_on ()
	else
       A2A_MasterIgnition_off ()
	end

end


function VoltmeterSelector_inc ()
    VoltSel = ipc.readLvar("Vol01234BBSelState")
    if VoltSel <= 5 then VoltSel = VoltSel + 1
    elseif VoltSel > 6 then VoltSel = 6
    end
    ipc.writeLvar("Vol01234BBSelState", VoltSel)
    VoltmeterSelector_show ()
end

function VoltmeterSelector_dec ()
    VoltSel = ipc.readLvar("Vol01234BBSelState")
    if VoltSel >= 1 then VoltSel = VoltSel - 1
    elseif VoltSel < 0 then VoltSel = 0
    end
    ipc.writeLvar("Vol01234BBSelState", VoltSel)
    VoltmeterSelector_show ()
end


-- $$ --------- Magnetos

function ENG_magneto_show ()
    if FVar == "0892" then
        EngMV = "1"
    elseif FVar == "092A" then
        EngMV = "2"
    elseif FVar == "09C2" then
        EngMV = "3"
    elseif FVar == "0A5A" then
        EngMV = "4"
    end
    if val == 0 then
        MagPos = " off"
    elseif val == 1 then
        MagPos = "rght"
    elseif val == 2 then
        MagPos = "left"
    elseif val == 3 then
        MagPos = "both"
    end
    DspShow("Mag" .. EngMV, MagPos)
end

function ALL_ENG_magneto_R ()
    ENG1_magneto_R()
    ENG2_magneto_R()
    ENG3_magneto_R()
    ENG4_magneto_R()
end

function ALL_ENG_magneto_L ()
	ENG1_magneto_L()
    ENG2_magneto_L()
    ENG3_magneto_L()
    ENG4_magneto_L()
end

function ALL_ENG_magneto_Both ()
    ENG1_magneto_Both()
    ENG2_magneto_Both()
    ENG3_magneto_Both()
    ENG4_magneto_Both()
end

function ALL_ENG_magneto_inc ()
    ENG1_magneto_inc()
    ENG2_magneto_inc()
    ENG3_magneto_inc()
    ENG4_magneto_inc()
end

function ALL_ENG_magneto_dec ()
    ENG1_magneto_dec()
    ENG2_magneto_dec()
    ENG3_magneto_dec()
    ENG4_magneto_dec()
end

function ENG1_magneto_R ()
	FVar = "0892"
    val = 1
	ipc.writeSB(FVar, val)
    ENG_magneto_show ()
end

function ENG1_magneto_L ()
	FVar = "0892"
    val = 2
	ipc.writeSB(FVar, val)
    ENG_magneto_show ()
end

function ENG1_magneto_Both ()
	FVar = "0892"
    val = 3
	ipc.writeSB(FVar, val)
    ENG_magneto_show ()
end

function ENG1_magneto_inc ()
	FVar = "0892"
	val = ipc.readSB(FVar)
	if val <= 2 then
    	val = val + 1
	end
	ipc.writeSB(FVar, val)
    ENG_magneto_show ()
end

function ENG1_magneto_dec ()
	FVar = "0892"
	val = ipc.readSB(FVar)
	if val >= 1 then
    	val = val - 1
	end
 	ipc.writeSB(FVar, val)
    ENG_magneto_show ()
end

function ENG2_magneto_R ()
	FVar = "092A"
    val = 1
	ipc.writeSB(FVar, val)
    ENG_magneto_show ()
end

function ENG2_magneto_L ()
	FVar = "092A"
    val = 2
	ipc.writeSB(FVar, val)
    ENG_magneto_show ()
end

function ENG2_magneto_Both ()
	FVar = "092A"
    val = 3
	ipc.writeSB(FVar, val)
    ENG_magneto_show ()
end

function ENG2_magneto_inc ()
	FVar = "092A"
	val = ipc.readSB(FVar)
	if val <= 2 then
    	val = val + 1
	end
	ipc.writeSB(FVar, val)
    ENG_magneto_show ()
end

function ENG2_magneto_dec ()
	FVar = "092A"
	val = ipc.readSB(FVar)
	if val >= 1 then
    	val = val - 1
	end
	ipc.writeSB(FVar, val)
    ENG_magneto_show ()
end

function ENG3_magneto_R ()
	FVar = "09C2"
    val = 1
	ipc.writeSB(FVar, val)
    ENG_magneto_show ()
end

function ENG3_magneto_L ()
	FVar = "09C2"
    val = 2
	ipc.writeSB(FVar, val)
    ENG_magneto_show ()
end

function ENG3_magneto_Both ()
	FVar = "09C2"
    val = 3
	ipc.writeSB(FVar, val)
    ENG_magneto_show ()
end

function ENG3_magneto_inc ()
	FVar = "09C2"
	val = ipc.readSB(FVar)
    if val <= 2 then
	   val = val + 1
	end
	ipc.writeSB(FVar, val)
    ENG_magneto_show ()
end

function ENG3_magneto_dec ()
	FVar = "09C2"
	val = ipc.readSB(FVar)
	if val >= 1 then
    	val = val - 1
	end
	ipc.writeSB(FVar, val)
    ENG_magneto_show ()
end

function ENG4_magneto_R ()
	FVar = "0A5A"
    val = 1
	ipc.writeSB(FVar, val)
    ENG_magneto_show ()
end

function ENG4_magneto_L ()
	FVar = "0A5A"
    val = 2
	ipc.writeSB(FVar, val)
    ENG_magneto_show ()
end

function ENG4_magneto_Both ()
	FVar = "0A5A"
    val = 3
	ipc.writeSB(FVar, val)
    ENG_magneto_show ()
end



function ENG4_magneto_inc ()
	FVar = "0A5A"
	val = ipc.readSB(FVar)
	if val <= 2 then
    	val = val + 1
	end
	ipc.writeSB(FVar, val)
    ENG_magneto_show ()
end

function ENG4_magneto_dec ()
	FVar = "0A5A"
	val = ipc.readSB(FVar)
	if val >= 1 then
    	val = val - 1
	end
	ipc.writeSB(FVar, val)
    ENG_magneto_show ()
end



-- ## Lights ###############

function A2A_Lights_LANDING_on ()
    ipc.writeLvar("LandingLightManualMode", 1)
    if ipc.readUW("028C") == 0 then
    ipc.control(65751)
    end
	DspShow ("LNDG", "on")
end

function A2A_Lights_LANDING_off ()
    if ipc.readUW("028C") == 1 then
    ipc.control(65751)
    end
	DspShow ("LNDG", "off")
end

function A2A_Lights_LANDING_toggle ()
	if ipc.readUW("028C") == 0 then
       A2A_Lights_LANDING_on ()
	else
       A2A_Lights_LANDING_off ()
	end
end


function A2A_LLExtend_on ()
    ipc.writeLvar("LandingLightExtendSwitch", 1)
    DspShow ("LLEx", "on")
end

function A2A_LLExtend_off ()
    ipc.writeLvar("LandingLightExtendSwitch", 0)
    DspShow ("LLEx", "off")
end

function A2A_LLExtend_toggle ()
	if _tl("LandingLightExtendSwitch", 0) then
       A2A_LLExtend_on ()
	else
       A2A_LLExtend_off ()
	end

end

function A2A_LandingLight_and_Extnd_on ()
    A2A_LLExtend_on ()
    _sleep(200,500)
    A2A_Lights_LANDING_on ()
end

function A2A_LandingLight_and_Extnd_off ()
    A2A_LLExtend_off ()
    _sleep(200,500)
    A2A_Lights_LANDING_off ()
end


function A2A_Lights_Passing_on ()

	ipc.setbitsUW("0d0c", 256)
    DspShow ("Pass", "on")
end

function A2A_Lights_Passing_off ()

	ipc.clearbitsUW("0d0c", 256)
end

function A2A_Lights_Passing_toggle ()
	if _t("pl") then
       A2A_Lights_Passing_on ()
	else
      A2A_Lights_Passing_off ()
	end
end



function A2A_TAIL_on ()
    n = ipc.readUW("0D0C")
    n = logic.Or(n, 1)
    ipc.writeUW("0D0C", n)
	DspShow ("TAIL", "on")
end

function A2A_TAIL_off ()
	ipc.clearbitsUW("0D0C", 1)
    DspShow ("TAIL", "off")
end

function A2A_TAIL_toggle ()
    if logic.And(ipc.readUW("0D0C"), 1) == 1 then
		A2A_TAIL_off ()
	else
		A2A_TAIL_on ()
	end
end

--

function A2A_WING_on ()
    n = ipc.readUW("0D0C")
    n = logic.Or(n, 128)
    ipc.writeUW("0D0C", n)
	DspShow ("WING", "on")
end

function A2A_WING_off ()
	ipc.clearbitsUW("0D0C", 128)
    DspShow ("WING", "off")
end

function A2A_WING_toggle ()
    if logic.And(ipc.readUW("0D0C"), 128) == 128 then
		A2A_WING_off ()
	else
		A2A_WING_on ()
	end
end


function A2A_WING_and_TAIL_on ()
    A2A_TAIL_on ()
    _sleep(100,200)
    A2A_WING_on ()
end

function A2A_WING_and_TAIL_off ()
    A2A_TAIL_off ()
    _sleep(100,200)
    A2A_WING_off ()
end


-- ## Interieur lights ###############

function CockpitLights_on ()
    n = ipc.readUW("0D0C")
    n = logic.Or(n, 64)
    ipc.writeUW("0D0C", n)
    DspShow ("CPLt", "on")
end

function CockpitLights_off ()
	ipc.clearbitsUW("0D0C", 64)
    DspShow ("CPLt", "off")
end

function CockpitLights_toggle ()
	n = ipc.readUW("0D0C")
	n = logic.Xor(n, 64)
	ipc.writeUW("0D0C", n)
end

function PaxCabinLights_on ()
    n = ipc.readUW("0D0C")
    n = logic.Or(n, 512)
    ipc.writeUW("0D0C", n)
    DspShow ("PaxL", "on")
end

function PaxCabinLights_off ()
	ipc.clearbitsUW("0D0C", 512)
    DspShow ("PaxL", "off")
end

function PaxCabinLights_toggle ()
	n = ipc.readUW("0D0C")
	n = logic.Xor(n, 512)
	ipc.writeUW("0D0C", n)
end

function CockpitAndPaxLights_on ()
    CockpitLights_on ()
    _sleep(150,300)
    PaxCabinLights_on ()
end

function CockpitAndPaxLights_off ()
    CockpitLights_off ()
    _sleep(150,300)
    PaxCabinLights_off ()
end

function InstrumentLight_UV ()
    ipc.writeLvar("L:GaugesLight", 1)
    DspShow ("Inst", "UV")
end

function InstrumentLight_Flourescent ()
    ipc.writeLvar("L:GaugesLight", 2)
    DspShow ("Inst", "FL")
end

function InstrumentLight_off ()
    ipc.writeLvar("L:GaugesLight", 0)
    DspShow ("Inst", "off")
end

function InstrumentLight_toggle ()
    IL = ipc.readLvar("L:GaugesLight")
    if IL == 1 then IL = 2 ILtext = "FL"
    elseif IL == 2 then IL = 0 ILtext = "off"
    elseif IL == 0 then IL = 1 ILtext = "UV"
    end
    ipc.writeLvar("L:GaugesLight", IL)
    DspShow ("Inst", ILtext)
end

function GPSLight_on ()
    ipc.writeLvar("L:GpsLightKnob", 60)
    DspShow ("GPSL", "on")
end

function GPSLight_off ()
    ipc.writeLvar("L:GpsLightKnob", 0)
    DspShow ("GPSL", "off")
end

function InstrAndGPSLights_toggle ()
    IL = ipc.readLvar("L:GaugesLight")
    if IL == 1 then IL = 2 ILtext = "FL" GPSLight_on ()
    elseif IL == 2 then IL = 0 ILtext = "off" GPSLight_off ()
    elseif IL == 0 then IL = 1 ILtext = "UV" GPSLight_on ()
    end
    ipc.writeLvar("L:GaugesLight", IL)
end



-- ## Engine Selection ###############

function A2A_EngineSelection_Eng1 ()

ipc.writeLvar("L:EngineSelection", 1)
DspShow(" ENG", "  1 ")
ipc.control(66507, 95)
end

function A2A_EngineSelection_Eng2 ()

ipc.writeLvar("L:EngineSelection", 2)
DspShow(" ENG", "  2 ")
ipc.control(66507, 95)
end

function A2A_EngineSelection_Eng3 ()

ipc.writeLvar("L:EngineSelection", 4)
DspShow(" ENG", "  3 ")
ipc.control(66507, 95)
end

function A2A_EngineSelection_Eng4 ()

ipc.writeLvar("L:EngineSelection", 8)
DspShow(" ENG", "  4 ")
ipc.control(66507, 95)
end

function A2A_EngineSelection_all ()

ipc.writeLvar("L:EngineSelection", 15)
DspShow(" ENG", " all")
ipc.sleep(1000)
ipc.control(66508, 95)
end


-- ## Primer ###############

function Primer_1_on ()
   ipc.writeLvar("L:Primer12Switch", 0)
   DspShow ("Prim", "#1")
end

function Primer_2_on ()
   ipc.writeLvar("L:Primer12Switch", 2)
   DspShow ("Prim", "#2")
end

function Primer_12_off ()
   ipc.writeLvar("L:Primer12Switch", 1)
   DspShow ("Prim", "off")
end

--

function Primer_3_on ()
   ipc.writeLvar("L:Primer34Switch", 0)
   DspShow ("Prim", "#3")
end

function Primer_4_on ()
   ipc.writeLvar("L:Primer34Switch", 2)
   DspShow ("Prim", "#4")
end

function Primer_34_off ()
   ipc.writeLvar("L:Primer34Switch", 1)
   DspShow ("Prim", "off")
end

function Selected_Primer_on ()
    ESelVar = ipc.readLvar("L:EngineSelection")
    if ESelVar == 1 then
        if ipc.readLvar("L:Primer34Switch") ~= 1 then Primer_34_off () end
    Primer_1_on ()
    elseif ESelVar == 2 then
        if ipc.readLvar("L:Primer34Switch") ~= 1 then Primer_34_off () end
    Primer_2_on ()
    elseif ESelVar == 4 then
        if ipc.readLvar("L:Primer12Switch") ~= 1 then Primer_12_off () end
    Primer_3_on ()
    elseif ESelVar == 8 then
        if ipc.readLvar("L:Primer12Switch") ~= 1 then Primer_12_off () end
    Primer_4_on ()
    else InertSelVar = 0
    end

end

function Selected_Primer_off ()
    Primer_12_off ()
    Primer_34_off ()
end


-- ## Engine start ###############

-- $$ Inertia

function Inert_1_on ()
    ipc.writeLvar("L:StartersInertia", 1)
    DspShow ("Inrt", "#1")
end

function Inert_2_on ()
    ipc.writeLvar("L:StartersInertia", 2)
    DspShow ("Inrt", "#2")
end

function Inert_3_on ()
    ipc.writeLvar("L:StartersInertia", 3)
    DspShow ("Inrt", "#3")
end

function Inert_4_on ()
    ipc.writeLvar("L:StartersInertia", 4)
    DspShow ("Inrt", "#4")
end

function Selected_Inert_on ()
    ESelVar = ipc.readLvar("L:EngineSelection")
    if ESelVar == 1 then InertSelVar = 1
    elseif ESelVar == 2 then InertSelVar = 2
    elseif ESelVar == 4 then InertSelVar = 3
    elseif ESelVar == 8 then InertSelVar = 4
    else InertSelVar = 0
    end

    ipc.writeLvar("L:StartersInertia", InertSelVar)
    DspShow ("Inrt", "#" .. InertSelVar)
end

function Inert_off ()
    ipc.writeLvar("L:StartersInertia", 0)
    DspShow ("Inrt", "off")
end

-- $$ Engage

function Engage_1_on ()
    ipc.writeLvar("L:StartersEngage", 1)
    DspShow ("Strt", "#1")
end

function Engage_2_on ()
    ipc.writeLvar("L:StartersEngage", 2)
    DspShow ("Strt", "#2")
end

function Engage_3_on ()
    ipc.writeLvar("L:StartersEngage", 3)
    DspShow ("Strt", "#3")
end

function Engage_4_on ()
    ipc.writeLvar("L:StartersEngage", 4)
    DspShow ("Strt", "#4")
end

function Selected_Engage_on ()
    ESelVar = ipc.readLvar("L:EngineSelection")
    if ESelVar == 1 then EngagSelVar = 1
    elseif ESelVar == 2 then EngagSelVar = 2
    elseif ESelVar == 4 then EngagSelVar = 3
    elseif ESelVar == 8 then EngagSelVar = 4
    else EngagSelVar = 0
    end

    ipc.writeLvar("L:StartersEngage", EngagSelVar)
    DspShow ("Strt", "#" .. EngagSelVar)
end

function Engage_off ()
    ipc.writeLvar("L:StartersEngage", 0)
    DspShow ("Strt", "off")
end

-- ## Prop RPM ###############

-- $$ Pedestal

function PropellerMasterSwitchRPM_inc ()
    ipc.writeLvar("PropellerMasterSwitchRPM", 2)
    Connie_RPM_showbig ()
end

function PropellerMasterSwitchRPM_dec ()
    ipc.writeLvar("PropellerMasterSwitchRPM", 0)
    Connie_RPM_showbig ()
end

function PropellerMasterSwitchRPM_neutral ()
    ipc.writeLvar("PropellerMasterSwitchRPM", 1)
    Connie_RPM_showbig ()
end

-- $$ Single Control

function Propeller1SwitchRPM_inc ()
    ipc.writeLvar("Propeller1SwitchRPM", 2)
    Eng1PRPM = math.floor(ipc.readLvar("Propeller1ControlRPM"))
    DspShow ("RPM1", Eng1PRPM, "Eng1 RPM", Eng1PRPM .. " %")
end

function Propeller1SwitchRPM_dec ()
    ipc.writeLvar("Propeller1SwitchRPM", 0)
    Eng1PRPM = math.floor(ipc.readLvar("Propeller1ControlRPM"))
    DspShow ("RPM1", Eng1PRPM, "Eng1 RPM", Eng1PRPM .. " %")
end

function Propeller1SwitchRPM_neutral ()
    ipc.writeLvar("Propeller1SwitchRPM", 1)
    Eng1PRPM = math.floor(ipc.readLvar("Propeller1ControlRPM"))
    DspShow ("RPM1", Eng1PRPM, "Eng1 RPM", Eng1PRPM .. " %")
end

--

function Propeller2SwitchRPM_inc ()
    ipc.writeLvar("Propeller2SwitchRPM", 2)
    Eng2PRPM = math.floor(ipc.readLvar("Propeller2ControlRPM"))
    DspShow ("RPM2", Eng2PRPM, "Eng2 RPM", Eng2PRPM .. " %")
end

function Propeller2SwitchRPM_dec ()
    ipc.writeLvar("Propeller2SwitchRPM", 0)
    Eng2PRPM = math.floor(ipc.readLvar("Propeller2ControlRPM"))
    DspShow ("RPM2", Eng2PRPM, "Eng2 RPM", Eng2PRPM .. " %")
end

function Propeller2SwitchRPM_neutral ()
    ipc.writeLvar("Propeller2SwitchRPM", 1)
    Eng2PRPM = math.floor(ipc.readLvar("Propeller2ControlRPM"))
    DspShow ("RPM2", Eng2PRPM, "Eng2 RPM", Eng2PRPM .. " %")
end

--

function Propeller3SwitchRPM_inc ()
    ipc.writeLvar("Propeller3SwitchRPM", 2)
    Eng3PRPM = math.floor(ipc.readLvar("Propeller3ControlRPM"))
    DspShow ("RPM3", Eng3PRPM, "Eng3 RPM", Eng3PRPM .. " %")
end

function Propeller3SwitchRPM_dec ()
    ipc.writeLvar("Propeller3SwitchRPM", 0)
    Eng3PRPM = math.floor(ipc.readLvar("Propeller3ControlRPM"))
    DspShow ("RPM3", Eng3PRPM, "Eng3 RPM", Eng3PRPM .. " %")
end

function Propeller3SwitchRPM_neutral ()
    ipc.writeLvar("Propeller3SwitchRPM", 1)
    Eng3PRPM = math.floor(ipc.readLvar("Propeller3ControlRPM"))
    DspShow ("RPM3", Eng3PRPM, "Eng3 RPM", Eng3PRPM .. " %")
end

--

function Propeller4SwitchRPM_inc ()
    ipc.writeLvar("Propeller4SwitchRPM", 2)
    Eng4PRPM = math.floor(ipc.readLvar("Propeller4ControlRPM"))
    DspShow ("RPM4", Eng4PRPM, "Eng4 RPM", Eng4PRPM .. " %")
end

function Propeller4SwitchRPM_dec ()
    ipc.writeLvar("Propeller4SwitchRPM", 0)
    Eng4PRPM = math.floor(ipc.readLvar("Propeller4ControlRPM"))
    DspShow ("RPM4", Eng4PRPM, "Eng4 RPM", Eng4PRPM .. " %")
end

function Propeller4SwitchRPM_neutral ()
    ipc.writeLvar("Propeller4SwitchRPM", 1)
    Eng4PRPM = math.floor(ipc.readLvar("Propeller4ControlRPM"))
    DspShow ("RPM4", Eng4PRPM, "Eng4 RPM", Eng4PRPM .. " %")
end

-- ## Cowl Flaps ###############
-- $$ Upper Cowl Flaps


function CowlUpperFlap1Switch_inc ()

    ipc.writeLvar("CowlUpperFlap1Switch", 2)
end

function CowlUpperFlap1Switch_dec ()

    ipc.writeLvar("CowlUpperFlap1Switch", 0)

end

function CowlUpperFlap1Switch_neutral ()

    ipc.writeLvar("CowlUpperFlap1Switch", 1)

end

--

function CowlUpperFlap2Switch_inc ()

    ipc.writeLvar("CowlUpperFlap2Switch", 2)

end

function CowlUpperFlap2Switch_dec ()

    ipc.writeLvar("CowlUpperFlap2Switch", 0)

end

function CowlUpperFlap2Switch_neutral ()

    ipc.writeLvar("CowlUpperFlap2Switch", 1)

end

--

function CowlUpperFlap3Switch_inc ()

    ipc.writeLvar("CowlUpperFlap3Switch", 2)

end

function CowlUpperFlap3Switch_dec ()

    ipc.writeLvar("CowlUpperFlap3Switch", 0)

end

function CowlUpperFlap3Switch_neutral ()

    ipc.writeLvar("CowlUpperFlap3Switch", 1)

end

--

function CowlUpperFlap4Switch_inc ()

    ipc.writeLvar("CowlUpperFlap4Switch", 2)

end

function CowlUpperFlap4Switch_dec ()

    ipc.writeLvar("CowlUpperFlap4Switch", 0)

end

function CowlUpperFlap4Switch_neutral ()

    ipc.writeLvar("CowlUpperFlap4Switch", 1)

end


------------------- lower CF
-- $$ Lower Cowl Flaps

function CowlLowerFlap1Switch_inc ()

    ipc.writeLvar("CowlLowerFlap1Switch", 2)
end

function CowlLowerFlap1Switch_dec ()

    ipc.writeLvar("CowlLowerFlap1Switch", 0)

end

function CowlLowerFlap1Switch_neutral ()

    ipc.writeLvar("CowlLowerFlap1Switch", 1)

end

--

function CowlLowerFlap2Switch_inc ()

    ipc.writeLvar("CowlLowerFlap2Switch", 2)

end

function CowlLowerFlap2Switch_dec ()

    ipc.writeLvar("CowlLowerFlap2Switch", 0)

end

function CowlLowerFlap2Switch_neutral ()

    ipc.writeLvar("CowlLowerFlap2Switch", 1)

end

--

function CowlLowerFlap3Switch_inc ()

    ipc.writeLvar("CowlLowerFlap3Switch", 2)

end

function CowlLowerFlap3Switch_dec ()

    ipc.writeLvar("CowlLowerFlap3Switch", 0)

end

function CowlLowerFlap3Switch_neutral ()

    ipc.writeLvar("CowlLowerFlap3Switch", 1)

end

--

function CowlLowerFlap4Switch_inc ()

    ipc.writeLvar("CowlLowerFlap4Switch", 2)

end

function CowlLowerFlap4Switch_dec ()

    ipc.writeLvar("CowlLowerFlap4Switch", 0)

end

function CowlLowerFlap4Switch_neutral ()

    ipc.writeLvar("CowlLowerFlap4Switch", 1)

end


-- $$ All CF


function CowlFlapsAll_inc ()
    if ipc.readLvar("GangSwitchCowlFlapON") < 90 then
    ipc.writeLvar("GangSwitchCowlFlapON", 100)
    ipc.control(66243)
    end

end

function CowlFlapsAll_dec ()

    if ipc.readLvar("GangSwitchCowlFlapOFF") < 90 then
    ipc.writeLvar("GangSwitchCowlFlapOFF", 100)
    ipc.control(66244)
    end
end

function CowlFlapsAll_neutral ()
    if ipc.readLvar("GangSwitchCowlFlapON") >= 90 then
    ipc.writeLvar("GangSwitchCowlFlapON", 0)
    ipc.control(66243)

    elseif ipc.readLvar("GangSwitchCowlFlapOFF") >= 90 then
    ipc.writeLvar("GangSwitchCowlFlapOFF", 0)
    ipc.control(66244)
    end

end

-- ## Carb Heat Levers ###############

function Eng1_CarbAirLever_off ()
    ipc.writeLvar("Eng1_CarbAirLever", 0)
    DspShow ("Crb1", "off")
end

function Eng1_CarbAirLever_inc ()
    Crb1 = math.floor(ipc.readLvar("Eng1_CarbAirLever"))
    if Crb1 <= 100 then
    Crb1 = Crb1 + 10
    else Crb1 = 100
    end

    ipc.writeLvar("Eng1_CarbAirLever", Crb1)
    DspShow ("Crb1", Crb1 .. "%", "CarbH #1", Crb1 .. "%")
end

function Eng1_CarbAirLever_dec ()
    Crb1 = math.floor(ipc.readLvar("Eng1_CarbAirLever"))
    if Crb1 >= 0 then
    Crb1 = Crb1 - 10
    else Crb1 = 0
    end

    ipc.writeLvar("Eng1_CarbAirLever", Crb1)
    DspShow ("Crb1", Crb1 .. "%", "CarbH #1", Crb1 .. "%")
end

--2

function Eng2_CarbAirLever_off ()
    ipc.writeLvar("Eng2_CarbAirLever", 0)
    DspShow ("Crb2", "off")
end

function Eng2_CarbAirLever_inc ()
    Crb2 = math.floor(ipc.readLvar("Eng2_CarbAirLever"))
    if Crb2 <= 100 then
    Crb2 = Crb2 + 10
    else Crb2 = 100
    end

    ipc.writeLvar("Eng2_CarbAirLever", Crb2)
    DspShow ("Crb2", Crb2 .. "%", "CarbH #2", Crb2 .. "%")
end

function Eng2_CarbAirLever_dec ()
    Crb2 = math.floor(ipc.readLvar("Eng2_CarbAirLever"))
    if Crb2 >= 0 then
    Crb2 = Crb2 - 10
    else Crb2 = 0
    end

    ipc.writeLvar("Eng2_CarbAirLever", Crb2)
    DspShow ("Crb2", Crb2 .. "%", "CarbH #2", Crb2 .. "%")
end

-- 3

function Eng3_CarbAirLever_off ()
    ipc.writeLvar("Eng3_CarbAirLever", 0)
    DspShow ("Crb3", "off")
end

function Eng3_CarbAirLever_inc ()
    Crb3 = math.floor(ipc.readLvar("Eng3_CarbAirLever"))
    if Crb3 <= 100 then
    Crb3 = Crb3 + 10
    else Crb3 = 100
    end

    ipc.writeLvar("Eng3_CarbAirLever", Crb3)
    DspShow ("Crb3", Crb3 .. "%", "CarbH #3", Crb3 .. "%")
end

function Eng3_CarbAirLever_dec ()
    Crb3 = math.floor(ipc.readLvar("Eng3_CarbAirLever"))
    if Crb3 >= 0 then
    Crb3 = Crb3 - 10
    else Crb3 = 0
    end

    ipc.writeLvar("Eng3_CarbAirLever", Crb3)
    DspShow ("Crb3", Crb3 .. "%", "CarbH #3", Crb3 .. "%")
end

-- 4

function Eng4_CarbAirLever_off ()
    ipc.writeLvar("Eng4_CarbAirLever", 0)
    DspShow ("Crb4", "off")
end

function Eng4_CarbAirLever_inc ()
    Crb4 = math.floor(ipc.readLvar("Eng4_CarbAirLever"))
    if Crb4 <= 100 then
    Crb4 = Crb4 + 10
    else Crb4 = 100
    end

    ipc.writeLvar("Eng4_CarbAirLever", Crb4)
    DspShow ("Crb4", Crb4 .. "%", "CarbH #4", Crb4 .. "%")
end

function Eng4_CarbAirLever_dec ()
    Crb4 = math.floor(ipc.readLvar("Eng4_CarbAirLever"))
    if Crb4 >= 0 then
    Crb4 = Crb4 - 10
    else Crb4 = 0
    end

    ipc.writeLvar("Eng4_CarbAirLever", Crb4)
    DspShow ("Crb4", Crb4 .. "%", "CarbH #4", Crb4 .. "%")
end

-- all

function EngAll_CarbAirLever_off ()
    ipc.writeLvar("Eng1_CarbAirLever", 0)
    ipc.writeLvar("Eng2_CarbAirLever", 0)
    ipc.writeLvar("Eng3_CarbAirLever", 0)
    ipc.writeLvar("Eng4_CarbAirLever", 0)
    DspShow ("CrbH", "off")
end

function EngAll_CarbAirLever_inc ()
    CrbH = math.floor(ipc.readLvar("Eng1_CarbAirLever"))
    if CrbH <= 100 then
    CrbH = CrbH + 10
    else CrbH = 100
    end

    ipc.writeLvar("Eng1_CarbAirLever", CrbH)
    ipc.writeLvar("Eng2_CarbAirLever", CrbH)
    ipc.writeLvar("Eng3_CarbAirLever", CrbH)
    ipc.writeLvar("Eng4_CarbAirLever", CrbH)
    DspShow ("CrbH", CrbH .. "%", "Carb Heat", CrbH .. "%")
end

function EngAll_CarbAirLever_dec ()
    CrbH = math.floor(ipc.readLvar("Eng1_CarbAirLever"))
    if CrbH >= 0 then
    CrbH = CrbH - 10
    else CrbH = 0
    end

    ipc.writeLvar("Eng1_CarbAirLever", CrbH)
    ipc.writeLvar("Eng2_CarbAirLever", CrbH)
    ipc.writeLvar("Eng3_CarbAirLever", CrbH)
    ipc.writeLvar("Eng4_CarbAirLever", CrbH)
    DspShow ("CrbH", CrbH .. "%", "Carb Heat", CrbH .. "%")
end



-- ## Supercharger ###############

function Eng1_Supercharger_on ()
    ipc.writeLvar("Eng1_SuperchargerPosition", 1)
    DspShow ("SC#1", "on", "S Chrg", "#1 on")
end

function Eng1_Supercharger_off ()
    ipc.writeLvar("Eng1_SuperchargerPosition", 0)
    DspShow ("SC#1", "off", "S Chrg", "#1 off")
end

function Eng1_Supercharger_toggle ()
	if _tl("Eng1_SuperchargerPosition", 0) then
       Eng1_Supercharger_on ()
	else
       Eng1_Supercharger_off ()
	end
end

--

function Eng2_Supercharger_on ()
    ipc.writeLvar("Eng2_SuperchargerPosition", 1)
    DspShow ("SC#2", "on", "S Chrg", "#2 on")
end

function Eng2_Supercharger_off ()
    ipc.writeLvar("Eng2_SuperchargerPosition", 0)
    DspShow ("SC#2", "off", "S Chrg", "#2 off")
end

function Eng2_Supercharger_toggle ()
	if _tl("Eng2_SuperchargerPosition", 0) then
       Eng2_Supercharger_on ()
	else
       Eng2_Supercharger_off ()
	end
end

--

function Eng3_Supercharger_on ()
    ipc.writeLvar("Eng3_SuperchargerPosition", 1)
    DspShow ("SC#3", "on", "S Chrg", "#3 on")
end

function Eng3_Supercharger_off ()
    ipc.writeLvar("Eng3_SuperchargerPosition", 0)
    DspShow ("SC#3", "off", "S Chrg", "#3 off")
end

function Eng3_Supercharger_toggle ()
	if _tl("Eng3_SuperchargerPosition", 0) then
       Eng3_Supercharger_on ()
	else
       Eng3_Supercharger_off ()
	end
end

--

function Eng4_Supercharger_on ()
    ipc.writeLvar("Eng4_SuperchargerPosition", 1)
    DspShow ("SC#4", "on", "S Chrg", "#4 on")
end

function Eng4_Supercharger_off ()
    ipc.writeLvar("Eng4_SuperchargerPosition", 0)
    DspShow ("SC#4", "off", "S Chrg", "#4 off")
end

function Eng4_Supercharger_toggle ()
	if _tl("Eng4_SuperchargerPosition", 0) then
       Eng4_Supercharger_on ()
	else
       Eng4_Supercharger_off ()
	end
end

function ALL_Supercharger_on ()
    ipc.writeLvar("Eng1_SuperchargerPosition", 1)
    ipc.writeLvar("Eng2_SuperchargerPosition", 1)
    ipc.writeLvar("Eng3_SuperchargerPosition", 1)
    ipc.writeLvar("Eng4_SuperchargerPosition", 1)
    DspShow ("SC", "on", "S Chrg", "all on")
end

function ALL_Supercharger_off ()
    ipc.writeLvar("Eng1_SuperchargerPosition", 0)
    ipc.writeLvar("Eng2_SuperchargerPosition", 0)
    ipc.writeLvar("Eng3_SuperchargerPosition", 0)
    ipc.writeLvar("Eng4_SuperchargerPosition", 0)
    DspShow ("SC", "off", "S Chrg", "all off")
end

function ALL_Supercharger_toggle ()
	if ipc.readLvar("Eng1_SuperchargerPosition") == 0 or
    ipc.readLvar("Eng2_SuperchargerPosition") == 0 or
    ipc.readLvar("Eng3_SuperchargerPosition") == 0 or
    ipc.readLvar("Eng4_SuperchargerPosition") == 0 then
    ALL_Supercharger_on ()
	else
    ALL_Supercharger_off ()
	end
end


-- ## Mixture Lever ###############

function MixtureRatioLever1Position_off ()
    ipc.writeLvar("MixtureRatioLever1Position", 0)
    DspShow ("Mix1", "off")
end

function MixtureRatioLever1Position_cruise ()
    ipc.writeLvar("MixtureRatioLever1Position", 1)
    DspShow ("Mix1", "crse")
end

function MixtureRatioLever1Position_rich ()
    ipc.writeLvar("MixtureRatioLever1Position", 2)
    DspShow ("Mix1", "rich")
end

--

function MixtureRatioLever2Position_off ()
    ipc.writeLvar("MixtureRatioLever2Position", 0)
    DspShow ("Mix2", "off")
end

function MixtureRatioLever2Position_cruise ()
    ipc.writeLvar("MixtureRatioLever2Position", 1)
    DspShow ("Mix2", "crse")
end

function MixtureRatioLever2Position_rich ()
    ipc.writeLvar("MixtureRatioLever2Position", 2)
    DspShow ("Mix2", "rich")
end

--

function MixtureRatioLever3Position_off ()
    ipc.writeLvar("MixtureRatioLever3Position", 0)
    DspShow ("Mix3", "off")
end

function MixtureRatioLever3Position_cruise ()
    ipc.writeLvar("MixtureRatioLever3Position", 1)
    DspShow ("Mix3", "crse")
end

function MixtureRatioLever3Position_rich ()
    ipc.writeLvar("MixtureRatioLever3Position", 2)
    DspShow ("Mix3", "rich")
end

--

function MixtureRatioLever4Position_off ()
    ipc.writeLvar("MixtureRatioLever4Position", 0)
    DspShow ("Mix4", "off")
end

function MixtureRatioLever4Position_cruise ()
    ipc.writeLvar("MixtureRatioLever4Position", 1)
    DspShow ("Mix4", "crse")
end

function MixtureRatioLever4Position_rich ()
    ipc.writeLvar("MixtureRatioLever4Position", 2)
    DspShow ("Mix4", "rich")
end


function MixtureALLLeverPosition_off ()
     ipc.writeLvar("MixtureRatioLever1Position", 0)
     ipc.writeLvar("MixtureRatioLever2Position", 0)
     ipc.writeLvar("MixtureRatioLever3Position", 0)
     ipc.writeLvar("MixtureRatioLever4Position", 0)
     DspShow ("Mix", "off")
end


function MixtureALLLeverPosition_cruise ()
     ipc.writeLvar("MixtureRatioLever1Position", 1)
     ipc.writeLvar("MixtureRatioLever2Position", 1)
     ipc.writeLvar("MixtureRatioLever3Position", 1)
     ipc.writeLvar("MixtureRatioLever4Position", 1)
     DspShow ("Mix", "crse")
end

function MixtureALLLeverPosition_rich ()
     ipc.writeLvar("MixtureRatioLever1Position", 2)
     ipc.writeLvar("MixtureRatioLever2Position", 2)
     ipc.writeLvar("MixtureRatioLever3Position", 2)
     ipc.writeLvar("MixtureRatioLever4Position", 2)
     DspShow ("Mix", "rich")
end


-- ## Fuel Pumps ###############

function A2A_FuelPump1_on ()

     ipc.setbitsUB("3125", 1)
     DspShow("Pmp1", " on ")
end

function A2A_FuelPump1_off ()

     ipc.clearbitsUB("3125", 1)
     DspShow("Pmp1", " off")
end

function A2A_FuelPump1_toggle ()

	if _t("pp1") then
       A2A_FuelPump1_on ()
	else
       A2A_FuelPump1_off ()
	end
end



function A2A_FuelPump2_on ()

     ipc.setbitsUB("3125", 2)
     DspShow("Pmp2", " on ")
end

function A2A_FuelPump2_off ()

     ipc.clearbitsUB("3125", 2)
     DspShow("Pmp2", " off")
end

function A2A_FuelPump2_toggle ()

	if _t("pp2") then
       A2A_FuelPump2_on ()
	else
       A2A_FuelPump2_off ()
	end
end



function A2A_FuelPump3_on ()

     ipc.setbitsUB("3125", 4)
     DspShow("Pmp3", " on ")
end

function A2A_FuelPump3_off ()

     ipc.clearbitsUB("3125", 4)
     DspShow("Pmp3", " off")
end

function A2A_FuelPump3_toggle ()

	if _t("pp3") then
       A2A_FuelPump3_on ()
	else
       A2A_FuelPump3_off ()
	end
end




function A2A_FuelPump4_on ()

     ipc.setbitsUB("3125", 8)
     DspShow("Pmp4", " on ")
end

function A2A_FuelPump4_off ()

     ipc.clearbitsUB("3125", 8)
     DspShow("Pmp4", " off")
end

function A2A_FuelPump4_toggle ()

	if _t("pp4") then
       A2A_FuelPump4_on ()
	else
       A2A_FuelPump4_off ()
	end
end


-- ## Air condition ###############

function AirConditionSwitch_on ()
    ipc.writeLvar("AirConditionSwitch", 1)
    DspShow ("A/C", "on")
end

function AirConditionSwitch_off ()
    ipc.writeLvar("AirConditionSwitch", 0)
    DspShow ("A/C", "off")
end

function AirConditionSwitch_toggle ()
	if _tl("AirConditionSwitch", 0) then
       AirConditionSwitch_on ()
	else
       AirConditionSwitch_off ()
	end
end


function BodyHeaterSwitch_on ()
    ipc.writeLvar("BodyHeaterSwitch", 1)
    DspShow ("Heat", "on")
end

function BodyHeaterSwitch_off ()
    ipc.writeLvar("BodyHeaterSwitch", 0)
    DspShow ("Heat", "off")
end

function BodyHeaterSwitch_toggle ()
	if _tl("BodyHeaterSwitch", 0) then
       BodyHeaterSwitch_on ()
	else
       BodyHeaterSwitch_off ()
	end
end


function CabinCoolingSwitch_on ()
    ipc.writeLvar("CabinCoolingSwitch", 1)
    DspShow ("Cool", "on")
end

function CabinCoolingSwitch_off ()
    ipc.writeLvar("CabinCoolingSwitch", 0)
    DspShow ("Cool", "off")
end

function CabinCoolingSwitch_toggle ()
	if _tl("CabinCoolingSwitch", 0) then
       CabinCoolingSwitch_on ()
	else
       CabinCoolingSwitch_off ()
	end
end



function GroundBlowerSwitch_on ()
    ipc.writeLvar("GroundBlowerSwitch", 1)
    DspShow ("Blow", "on")
end

function GroundBlowerSwitch_off ()
    ipc.writeLvar("GroundBlowerSwitch", 0)
    DspShow ("Blow", "off")
end

function GroundBlowerSwitch_toggle ()
	if _tl("GroundBlowerSwitch", 0) then
       GroundBlowerSwitch_on ()
	else
       GroundBlowerSwitch_off ()
	end
end

-- $$ Pressuration System ############

----------------------------------------------pressuration system


function A2A_CabinRateGoal_inc ()

	LVarSet = "L:CabinAltRateGoalKnob"


 	LvarVar = ipc.readLvar(LVarSet)
	if LvarVar <= 99 then
 	val = LvarVar + 1
	elseif LvarVar == 100 then
 	val = 100
	end


	ipc.writeLvar(LVarSet, val)
	ipc.sleep(100)
	CVal = ipc.readLvar("L:CabinAltRateGoal")
	DspShow("CRat", CVal, "Cab Rate", CVal .. " ft/m")

end


function A2A_CabinRateGoal_dec ()

	LVarSet = "L:CabinAltRateGoalKnob"


 	LvarVar = ipc.readLvar(LVarSet)
	if LvarVar >= 1 then
 	val = LvarVar - 1
	elseif LvarVar == 0 then
 	val = 0
	end


	ipc.writeLvar(LVarSet, val)
	ipc.sleep(100)
	CVal = ipc.readLvar("L:CabinAltRateGoal")
    DspShow("CRat", CVal, "Cab Rate", CVal .. "ft/min")


end




function A2A_CabinPressureGoal_inc ()

	LVarSet = "L:CabinAltGoalKnob"


 	LvarVar = ipc.readLvar(LVarSet)
	if LvarVar <= 99 then
 	val = LvarVar + 1
	elseif LvarVar == 100 then
 	val = 100
	end


	ipc.writeLvar(LVarSet, val)
	ipc.sleep(100)
	CVal = math.floor(ipc.readLvar("L:CabinAltGoal"))
    A2A_CabinPressure_show ()

end


function A2A_CabinPressureGoal_dec ()

	LVarSet = "L:CabinAltGoalKnob"


 	LvarVar = ipc.readLvar(LVarSet)
	if LvarVar >= 1 then
 	val = LvarVar - 1
	elseif LvarVar == 0 then
 	val = 0
	end


	ipc.writeLvar(LVarSet, val)
	ipc.sleep(100)
	CVal = math.floor(ipc.readLvar("L:CabinAltGoal"))
    A2A_CabinPressure_show ()


end
-- ## Radios ###############

function A2A_VOR1 ()
	ipc.writeLvar("L:RMI1", 0)
    DspShow ("VOR", " 1")
end


function A2A_ADF1 ()
	ipc.writeLvar("L:RMI1", 1)
    DspShow ("ADF", " 1")
end


function A2A_VOR2 ()
	ipc.writeLvar("L:RMI2", 0)
    DspShow ("VOR", " 2")
end


function A2A_ADF2 ()
	ipc.writeLvar("L:RMI2", 1)
    DspShow ("ADF", " 2")
end

function A2A_AdfVor1_toggle ()
	if _tl("RMI1", 0) then
        A2A_ADF1 ()
	else
        A2A_VOR1 ()
	end
end

function A2A_AdfVor2_toggle ()
	if _tl("RMI2", 0) then
        A2A_ADF2 ()
	else
        A2A_VOR2 ()
	end
end



-- ## other ###############

function WindowDefrosterSwitch_on ()
    ipc.writeLvar("WindowDefrosterSwitch", 1)
    DspShow ("Defr", "on")
end

function WindowDefrosterSwitch_off ()
    ipc.writeLvar("WindowDefrosterSwitch", 0)
    DspShow ("Defr", "off")
end

function WindowDefrosterSwitch_toggle ()
	if _tl("WindowDefrosterSwitch", 0) then
       WindowDefrosterSwitch_on ()
	else
       WindowDefrosterSwitch_off ()
	end
end



function CHT_Selector_knob_off ()
    ipc.writeLvar("CHTselectorPos", 0)
    CHT_Selector_show ()
end

function CHT_Selector_knob_1 ()
    ipc.writeLvar("CHTselectorPos", 1)
    CHT_Selector_show ()
end

function CHT_Selector_knob_2 ()
    ipc.writeLvar("CHTselectorPos", 2)
    CHT_Selector_show ()
end

function CHT_Selector_knob_3 ()
    ipc.writeLvar("CHTselectorPos", 3)
    CHT_Selector_show ()
end

function CHT_Selector_knob_4 ()
    ipc.writeLvar("CHTselectorPos", 4)
    CHT_Selector_show ()
end

function CHT_Selector_inc ()
    CHTSelVar = ipc.readLvar("CHTselectorPos")
    if CHTSelVar < 4 then
    CHTSelVar = CHTSelVar + 1
    else CHTSelVar = 4
    end
    ipc.writeLvar("CHTselectorPos", CHTSelVar)
    CHT_Selector_show ()
end

function CHT_Selector_dec ()
    CHTSelVar = ipc.readLvar("CHTselectorPos")
    if CHTSelVar > 0 then
    CHTSelVar = CHTSelVar - 1
    else CHTSelVar = 0
    end
    ipc.writeLvar("CHTselectorPos", CHTSelVar)
    CHT_Selector_show ()
end

function CHT_Selector_toggle ()
    CHTSelVar = ipc.readLvar("CHTselectorPos")
    if CHTSelVar < 4 then
    CHTSelVar = CHTSelVar + 1
    else CHTSelVar = 0
    end
    ipc.writeLvar("CHTselectorPos", CHTSelVar)
    CHT_Selector_show ()
end


